WSADESCRIPTION_LEN		equ	  256		;description length
WSASYS_STATUS_LEN		equ	  128		;system status length
WSAINPUTSIZE			equ	 8192		;input buffer size
WSAFTPCMDSIZE			equ	  128		;ftp command size
WSAMAXUSERNAME			equ	   64		;max user name length
WSAMAXPASSWORD			equ	   32		;max password length
WSAMAXFILENAME			equ	   64		;max file name length
WSAMAXHOSTNAME			equ	  255		;max host name length
WSAMAXADDRSTR			equ	   16		;max addr string length
WSAMAXGETHOSTSTRUCT		equ	 1024		;hostent buffer size
WSAMAXTTL			equ	  255		;max time to live

; ===================
; ip address families
; ===================
;
AF_UNSPEC		equ	 0
AF_UNIX			equ	 1
AF_INET			equ	 2
AF_IMPLINK		equ	 3
AF_PUP			equ	 4
AF_CHAOS		equ	 5
AF_IPX			equ	 6
AF_NS			equ	 6
AF_ISO			equ	 7
AF_OSI			equ	 7
AF_ECMA			equ	 8
AF_DATAKIT		equ	 9
AF_CCITT		equ	10
AF_SNA			equ	11
AF_DECnet		equ	12
AF_DLI			equ	13
AF_LAT			equ	14
AF_HYLINK		equ	15
AF_APPLETALK		equ	16
AF_NETBIOS		equ	17
AF_VOICEVIEW		equ	18
AF_FIREFOX		equ	19
AF_UNKNOWN1		equ	20
AF_BAN			equ	21
;
AF_MAX			equ	22

;------------------------------------------------------------------------------
;
; ====================
; ip protocol families
; ====================
;
PF_UNSPEC			equ	AF_UNSPEC
PF_UNIX				equ	AF_UNIX
PF_INET				equ	AF_INET
PF_IMPLINK			equ	AF_IMPLINK
PF_PUP				equ	AF_PUP
PF_CHAOS			equ	AF_CHAOS
PF_NS				equ	AF_NS
PF_IPX				equ	AF_IPX
PF_ISO				equ	AF_ISO
PF_OSI				equ	AF_OSI
PF_ECMA				equ	AF_ECMA
PF_DATAKIT			equ	AF_DATAKIT
PF_CCITT			equ	AF_CCITT
PF_SNA				equ	AF_SNA
PF_DECnet			equ	AF_DECnet
PF_DLI				equ	AF_DLI
PF_LAT				equ	AF_LAT
PF_HYLINK			equ	AF_HYLINK
PF_APPLETALK			equ	AF_APPLETALK
PF_VOICEVIEW			equ	AF_VOICEVIEW
PF_FIREFOX			equ	AF_FIREFOX
PF_UNKNOWN1			equ	AF_UNKNOWN1
PF_BAN				equ	AF_BAN
;
PF_MAX				equ	AF_MAX

;
;------------------------------------------------------------------------------
;
; ===================
; winsock error codes
; ===================
;
WSABASEERR			equ	10000
;
WSAEINTR			equ	WSABASEERR+0004
WSAEBADF			equ	WSABASEERR+0009
WSAEACCES			equ	WSABASEERR+0013
WSAEFAULT			equ	WSABASEERR+0014
WSAEINVAL			equ	WSABASEERR+0022
WSAEMFILE			equ	WSABASEERR+0024
;
WSAEWOULDBLOCK			equ	WSABASEERR+0035
WSAEINPROGRESS			equ	WSABASEERR+0036
WSAEALREADY			equ	WSABASEERR+0037
WSAENOTSOCK			equ	WSABASEERR+0038
WSAEDESTADDRREQ			equ	WSABASEERR+0039
WSAEMSGSIZE			equ	WSABASEERR+0040
WSAEPROTOTYPE			equ	WSABASEERR+0041
WSAENOPROTOOPT			equ	WSABASEERR+0042
WSAEPROTONOSUPPORT		equ	WSABASEERR+0043
WSAESOCKTNOSUPPORT		equ	WSABASEERR+0044
WSAEOPNOTSUPP			equ	WSABASEERR+0045
WSAEPFNOSUPPORT			equ	WSABASEERR+0046
WSAEAFNOSUPPORT			equ	WSABASEERR+0047
WSAEADDRINUSE			equ	WSABASEERR+0048
WSAEADDRNOTAVAIL		equ	WSABASEERR+0049
WSAENETDOWN			equ	WSABASEERR+0050
WSAENETUNREACH			equ	WSABASEERR+0051
WSAENETRESET			equ	WSABASEERR+0052
WSAECONNABORTED			equ	WSABASEERR+0053
WSAECONNRESET			equ	WSABASEERR+0054
WSAENOBUFS			equ	WSABASEERR+0055
WSAEISCONN			equ	WSABASEERR+0056
WSAENOTCONN			equ	WSABASEERR+0057
WSAESHUTDOWN			equ	WSABASEERR+0058
WSAETOOMANYREFS			equ	WSABASEERR+0059
WSAETIMEDOUT			equ	WSABASEERR+0060
WSAECONNREFUSED			equ	WSABASEERR+0061
WSAELOOP			equ	WSABASEERR+0062
WSAENAMETOOLONG			equ	WSABASEERR+0063
WSAEHOSTDOWN			equ	WSABASEERR+0064
WSAEHOSTUNREACH			equ	WSABASEERR+0065
WSAENOTEMPTY			equ	WSABASEERR+0066
WSAEPROCLIM			equ	WSABASEERR+0067
WSAEUSERS			equ	WSABASEERR+0068
WSAEDQUOT			equ	WSABASEERR+0069
WSAESTALE			equ	WSABASEERR+0070
WSAEREMOTE			equ	WSABASEERR+0071
WSAEDISCON			equ	WSABASEERR+0101
;
WSASYSNOTREADY			equ	WSABASEERR+0091
WSAVERNOTSUPPORTED		equ	WSABASEERR+0092
WSANOTINITIALISED		equ	WSABASEERR+0093
;
WSAHOST_NOT_FOUND		equ	WSABASEERR+1001
WSATRY_AGAIN			equ	WSABASEERR+1002
WSANO_RECOVERY			equ	WSABASEERR+1003
WSANO_DATA			equ	WSABASEERR+1004
;
WSANO_ADDRESS			equ	WSANO_DATA
;
HOST_NOT_FOUND			equ	WSAHOST_NOT_FOUND
TRY_AGAIN			equ	WSATRY_AGAIN
NO_RECOVERY			equ	WSANO_RECOVERY
NO_DATA				equ	WSANO_DATA
NO_ADDRESS			equ	WSANO_ADDRESS
;
;------------------------------------------------------------------------------
; ===================
; ip protocol numbers
; ===================
;
IPPROTO_IP			equ	  0
IPPROTO_ICMP			equ	  1
IPPROTO_IGMP			equ	  2
IPPROTO_GGP			equ	  3
IPPROTO_TCP			equ	  6
IPPROTO_PUP			equ	 12
IPPROTO_UDP			equ	 17
IPPROTO_IDP			equ	 22
IPPROTO_ND			equ	 77
;
IPPROTO_RAW			equ	255
IPPROTO_MAX			equ	256
;------------------------------------------------------------------------------
; ============
; socket types
; ============
;
SOCK_STREAM			equ	 1
SOCK_DGRAM			equ	 2
SOCK_RAW			equ	 3
SOCK_RDM			equ	 4
SOCK_SEQPACKET			equ	 5
;
INVALID_SOCKET			equ	-1
SOCKET_ERROR			equ	-1
;
;------------------------------------------------------------------------------
;
; =============
; socket events
; =============
;
FD_READ			equ	00000001h
FD_WRITE		equ	00000002h
FD_OOB			equ	00000004h
FD_ACCEPT		equ	00000008h
FD_CONNECT		equ	00000010h
FD_CLOSE		equ	00000020h
;
;------------------------------------------------------------------------------

;
SOCKADDR		struct
sa_family		WORD	  0		;address family
sa_data			BYTE	  14 dup (0)	;direct address
SOCKADDR		ends
SOCKADDR_		equ	  2+14
;
;------------------------------------------------------------------------------
;
WSADATA			struct
wsa_wVersion		WORD	  0		;expected caller version
wsa_wHighVersion	WORD	  0		;highest version supported
wsa_szDescription	BYTE	  WSADESCRIPTION_LEN+1 dup (0)	;description
wsa_szSystemStatus	BYTE	  WSASYS_STATUS_LEN+1 dup (0)	;system status
wsa_iMaxSockets		WORD	  0		;maximum # of sockets
wsa_iMaxUdpDg		WORD	  0		;maximum udp datagram size
wsa_lpVendorInfo	DWORD	  0		;vendor info structure
WSADATA			ends
;
;==============================================================================

