.386P
.Model Flat ,StdCall

INCLUDE	defines.inc

extrn	lstrlen		: PROC
extrn	HeapCreate	: PROC
extrn	HeapDestroy	: PROC
extrn	SetTimer	: PROC
extrn	KillTimer	: PROC
extrn	keybd_event	: PROC

extrn	MainWnd		: DWORD
.Data
	hHookTask	DD	0


	Memory_Heap	DD	?
PUBLIC	Memory_Heap


	lpOldGate	DD	0 
	IDT		DB	6 dup (0)

	KeybPlaying	DB	0

.Code

; init / deinit our memory manager....

PUBLIC		InitMemMgr
InitMemMgr	PROC
	call	HeapCreate, HEAP_GENERATE_EXCEPTIONS, 0, 0
	mov	Memory_Heap, eax
	ret
InitMemMgr	ENDP


PUBLIC		DeInitMemMgr
DeInitMemMgr	PROC
	call	HeapDestroy, Memory_Heap
	ret
DeInitMemMgr	ENDP


PUBLIC	strstr
PUBLIC	atoi
PUBLIC	htoi

; does a string occurs inside another ?
strstr		PROC
	push	esi
	call	lstrlen
	cld

@@ss_find:
	cmp	BYTE PTR [edi], 0
	jz	@@ss_no
	push	esi
	push	edi
	mov	ecx, eax
	repe	cmpsb
	pop	edi
	pop	esi
	je	@@ss_eq
	inc	edi
	jmp	@@ss_find
@@ss_no:
	xor	edi, edi
	ret
@@ss_eq:
	ret
strstr		ENDP

; string to dec, string "12" => 12
atoi		PROC
	xor	ebx, ebx
	or	esi, esi
	jz	@@atoi_done
	cld
@@atoi_0:
	cmp	BYTE PTR [esi], 20h
	jne	@@atoi_start
	inc	esi
	jmp	@@atoi_0
@@atoi_start:
	lodsb
	sub	al, '0'
	cmp	al, 9
	ja	@@atoi_done
	movzx	eax, al
	imul	ebx, 10
	add	ebx, eax
	jmp	@@atoi_start
@@atoi_done:
	ret
atoi		ENDP

; string to hex, "12" => 0x12 = 18
htoi		PROC
	xor	ebx, ebx
	or	esi, esi
	jz	@@htoi_done
	cld
@@htoi_0:
	cmp	BYTE PTR [esi], 20h
	jne	@@htoi_start
	inc	esi
	jmp	@@htoi_0
@@htoi_start:
	lodsb
	sub	al, '0'
	cmp	al, 9
	jbe	@@htoi_set

	sub	al, 'A' - '0' - 10
	cmp	al, 15
	jbe	@@htoi_set

	sub	al, 'a' - 'A'
	cmp	al, 15
	ja	@@htoi_done
@@htoi_set:
	movzx	eax, al
	shl	ebx, 4
	add	ebx, eax
	jmp	@@htoi_start
@@htoi_done:
	ret
htoi		ENDP


; run some code in RING0 (highest privilege, can use all opcode, eg HLT)

ExceptionUsed	EQU	5

PUBLIC		RunRing0
RunRing0	PROC	p:DWORD
	sidt	FWORD PTR IDT
	mov 	ebx, DWORD PTR [IDT+2]		; ebx -> IDT
	add	ebx, 8*ExceptionUsed		; Ebx -> IDT entry of ExceptionUsed
	cli					; Clear interupts
	mov	dx, WORD PTR [ebx+6]		; Save the current gate highword
	shl	edx, 16
	mov	dx, WORD PTR [ebx]		; lowword
	mov	[lpOldGate], edx
	mov	eax, p				; "install hook" - that is newgate
	mov	WORD PTR [ebx], ax		; lowword
	shr	eax, 16
	mov	WORD PTR [ebx+6], ax		; highword
	int 	ExceptionUsed			; cause exception
	mov	ebx, DWORD PTR [IDT+2]		; restore gate
	add	ebx, 8*ExceptionUsed
	mov	edx, [lpOldGate]
	mov	WORD PTR [ebx], dx
	shr	edx, 16
	mov	WORD PTR [ebx+6], dx
	ret
RunRing0	ENDP

; simulate a keypress
PUBLIC	PressKeyBoard
PressKeyBoard	PROC
	push	0
	push	KEYEVENTF_KEYUP	
	push	0
	push	eax
	call	keybd_event, eax, 0, 0, 0
	call	keybd_event
	ret
PressKeyBoard	ENDP


; keyboard got stuck?
PUBLIC	PlayKeybLight
PlayKeybLight	PROC
	cmp	KeybPlaying, 0
	jne	@@ByPassPlayKeyBoard
	mov	KeybPlaying, 1
	call	SetTimer, MainWnd, TIMER_PLAYKEYB, 400, 0
@@ByPassPlayKeyBoard:
	ret
PlayKeybLight	ENDP

; enough, stop it.
PUBLIC	StopKeybLight
StopKeybLight	PROC
	cmp	KeybPlaying, 0
	je	@@ByPassStopKeyBoard
	mov	KeybPlaying, 0
	call	KillTimer, MainWnd, TIMER_PLAYKEYB
@@ByPassStopKeyBoard:
	ret
StopKeybLight	ENDP

END